# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section     free
%define jettyname   jetty
%define servletspec 2.5
%define jspspec     2.1



# FHS 2.3 compliant tree structure - http://www.pathname.com/fhs/
%define appdir /srv/jetty6/webapps
%define ctxdir /srv/jetty6/contexts
%define confdir %{_sysconfdir}/jetty6
%define homedir %{_datadir}/jetty6
%define libdir %{_javadir}/jetty6
%define logdir %{_localstatedir}/log/jetty6
#%define tempdir %{_localstatedir}/tmp/jetty6
#%define workdir %{_localstatedir}/cache/jetty6



Name:           jetty6
Version:        6.1.7
Release:        2jpp
Epoch:          0
Summary:        The Jetty Webserver and Servlet Container

Group:          Networking/Daemons
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
License:        Apache Software License
URL:            http://www.mortbay.org/
Source0:        http://dist.codehaus.org/jetty/jetty-%{version}/jetty-%{version}-src.zip
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-start.config
Source4:        %{name}-jetty.conf
Source5:        %{name}-glassfish-jsp-2.1-src.tgz
# steps to reproduce
# cd modules
# mkdir -p tmp/modules/jsp-api-2.1
# cp jsp-api-2.1/checkout.xml tmp/modules/jsp-api-2.1
# pushd tmp/modules/jsp-api-2.1
# ant -Dglassfish.tag=SJSAS-9_1-B58C-FCS-22_Aug_2007 -f checkout.xml extract-src
# popd
# mkdir -p tmp/modules/jsp-2.1
# cp jsp-2.1/checkout.xml tmp/modules/jsp-2.1
# pushd tmp/modules/jsp-2.1
# ant -Dglassfish.tag=SJSAS-9_1-B58C-FCS-22_Aug_2007 -f checkout.xml extract-src
# popd
# cd tmp
# tar czf jetty6-glassfish-jsp-2.1-src.tgz modules

Patch0:         %{name}-felix.patch
Patch1:         %{name}-pom.patch
Patch2:         %{name}-jsp-api-2.0-pom_xml.patch
Patch3:         %{name}-extras-xbean-pom_xml.patch
Patch4:         %{name}-jsp-2.1-pom.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.4
BuildRequires:  java-devel = 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-junit
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  jmock

BuildRequires:  maven2 >= 2.0.4-10jpp
BuildRequires:  maven2-default-skin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jxr
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-war
BuildRequires:  mojo-maven2-plugin-dependency

BuildRequires:  ecj
BuildRequires:  derby
BuildRequires:  geronimo-specs-poms
BuildRequires:  geronimo-jta-1.0.1B-api
BuildRequires:  geronimo-annotation-1.0-api
BuildRequires:  jakarta-commons-el
BuildRequires:  jakarta-slide-webdavclient
BuildRequires:  mx4j
BuildRequires:  qdox
BuildRequires:  slf4j
BuildRequires:  sun-mail
BuildRequires:  sun-jaf
BuildRequires:  xbean

Requires:          java-devel = 0:1.5.0
Requires:          %{name}-core = %{epoch}:%{version}-%{release}
Requires(post):    jpackage-utils >= 0:1.7.4
Requires(postun):  jpackage-utils >= 0:1.7.4

%description
Jetty is a 100% Java HTTP Server and Servlet Container.


%package -n %{jettyname}6-servlet-%{servletspec}-api
Summary:        Servlet 2.5 API from %{name}
Group:          Networking/Daemons
Requires: %{name} = %{epoch}:%{version}-%{release}
Provides: servlet_api
Provides: servlet_2_5_api

%description -n %{jettyname}6-servlet-%{servletspec}-api
%{summary}.


%package -n %{jettyname}6-jsp-%{jspspec}
Summary:        JSP 2.1 API from %{name}
Group:          Networking/Daemons
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: servlet_2_5_api
Requires: ecj
Provides: jsp_api
Provides: jsp_2_1_api
Provides: jsp_impl
Provides: jsp_2_1_impl

%description -n %{jettyname}6-jsp-%{jspspec}
%{summary}.


%package -n %{jettyname}6-jsp-2.0
Summary:        JSP 2.0 API from %{name}
Group:          Networking/Daemons
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: servlet_2_4_api
Requires: ant
Requires: jakarta-commons-el
Requires: slf4j
Requires: tomcat5-jasper
Requires: xerces-j2
Requires: xml-commons-jaxp-1.3-apis
Provides: jsp_api
Provides: jsp_2_0_api
Provides: jsp_impl
Provides: jsp_2_0_impl

%description -n %{jettyname}6-jsp-2.0
%{summary}.


%package -n %{jettyname}6-core
Summary:        Core libraries for %{name}
Group:          Networking/Daemons
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: servlet_2_5_api

%description -n %{jettyname}6-core
%{summary}.


%package -n %{jettyname}6-ext
Summary:        Extension libraries for %{name}
Group:          Networking/Daemons
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: java >= 0:1.5.0

%description -n %{jettyname}6-ext
%{summary}.


%package -n %{jettyname}6-plus
Summary:        JavaEE style services for %{name}
Group:          Networking/Daemons
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: %{name}-naming = %{epoch}:%{version}-%{release}
Requires: jta_api

%description -n %{jettyname}6-plus
%{summary}.


%package -n %{jettyname}6-annotations
Summary:        Servlet Annotations for %{name}
Group:          Networking/Daemons
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: %{name}-plus = %{epoch}:%{version}-%{release}
Requires: %{name}-naming = %{epoch}:%{version}-%{release}
Requires: java >= 0:1.5.0
Requires: annotation_1_0_api

%description -n %{jettyname}6-annotations
%{summary}.


%package -n %{jettyname}6-management
Summary:        JMX for %{name}
Group:          Networking/Daemons
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: mx4j >= 0:3.0.1

%description -n %{jettyname}6-management
%{summary}.


%package -n %{jettyname}6-naming
Summary:        JNDI for %{name}
Group:          Networking/Daemons
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: jaf_1_1_api
Requires: javamail_1_4_api

%description -n %{jettyname}6-naming
%{summary}.


%package -n %{jettyname}6-spring
Summary:        Spring for %{name}
Group:          Networking/Daemons
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: %{name}-plus = %{epoch}:%{version}-%{release}
Requires: spring

%description -n %{jettyname}6-spring
%{summary}.


%package -n %{jettyname}6-xbean
Summary:        XBean for %{name}
Group:          Networking/Daemons
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: %{name}-plus = %{epoch}:%{version}-%{release}
Requires: qdox
Requires: spring
Requires: xbean

%description -n %{jettyname}6-xbean
%{summary}.


%package -n %{jettyname}6-maven2-plugins
Summary:        Maven2 plugins for %{name}
Group:          Development/Java
Requires: %{name}-core = %{epoch}:%{version}-%{release}
Requires: maven2

%description -n %{jettyname}6-maven2-plugins
%{summary}.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%prep
%setup -q -n %{jettyname}-%{version}
tar xzf %{SOURCE5}
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4

cp %{SOURCE3} etc/start.config
cp %{SOURCE4} etc/jetty.conf

# test fails with spring 1.2.9
rm extras/xbean/src/test/java/org/mortbay/jetty/xbean/XBeanTest.java
# location referenced by ${user.dir}
mkdir -p src/test/resources
cp extras/sslengine/src/test/resources/keystore src/test/resources


%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir -p .m2/repository/javax.servlet.jsp/
ln -sf $(pwd)/modules/jsp-api-2.1/target/jsp-api-2.1-%{version}.jar .m2/repository/javax.servlet.jsp/jsp-api.jar

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export JAVA_HOME=%{_jvmdir}/java-1.5.0
mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Djboss.home=/usr/share/jboss4 \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install 
#        install javadoc:javadoc
mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Djboss.home=/usr/share/jboss4 \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:javadoc 

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

# ********************* INSTALL Files To Fake RPM File Structure **************************

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jetty6

install -m 644 start.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/start-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6
    ln -sf start-%{version}.jar start.jar
popd


# ================= Start of Servlet subpackage install

# install jar files
install -m 644 lib/servlet-api-%{servletspec}-%{version}.jar \
        ${RPM_BUILD_ROOT}%{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar
# create symbolic links
pushd ${RPM_BUILD_ROOT}%{_javadir}
        ln -sf %{jettyname}6-servlet-%{servletspec}-api-%{version}.jar \
            %{jettyname}6-servlet-%{servletspec}-api.jar
popd

# ================= End of Servlet subpackage install



# ================= Start of JSP 2.1 subpackage install
# create folder
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/jsp-2.1

# install jar files
install -m 644 lib/jsp-2.1/jsp-2.1.jar ${RPM_BUILD_ROOT}%{_javadir}/jetty6/jsp-2.1/jsp-2.1-%{version}.jar
install -m 644 lib/jsp-2.1/jsp-api-2.1.jar ${RPM_BUILD_ROOT}%{_javadir}/jetty6/jsp-2.1/jsp-api-2.1-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/jsp-2.1
    ln -sf jsp-2.1-%{version}.jar jsp-2.1.jar
    ln -sf jsp-api-2.1-%{version}.jar jsp-api-2.1.jar
popd
# ================= End of JSP 2.1 subpackage install


# ================= Start of JSP 2.0 subpackage install
# create folder
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/jsp-2.0

# install jar files
install -m 644 lib/jsp-2.0/jsp-api-2.0.jar ${RPM_BUILD_ROOT}%{_javadir}/jetty6/jsp-2.0/jsp-api-2.0-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/jsp-2.0
    ln -sf $(build-classpath ant)
    ln -sf $(build-classpath commons-el)
    ln -sf $(build-classpath ecj)
    ln -sf $(build-classpath jasper5-compiler)
    ln -sf $(build-classpath jasper5-runtime)
    ln -sf $(build-classpath slf4j/jcl104-over-slf4j)
    ln -sf $(build-classpath slf4j/api) slf4j-api.jar
    ln -sf $(build-classpath slf4j/simple) slf4j-simple.jar
    ln -sf $(build-classpath xerces-j2)
    ln -sf $(build-classpath xml-commons-jaxp-1.3-apis)
popd
# ================= End of JSP 2.0 subpackage install


# ================= Start of Jetty-Core subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/core
install -m 644 lib/jetty-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/core/jetty6-%{version}.jar
install -m 644 lib/jetty-util-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/core/jetty6-util-%{version}.jar
install -m 644 lib/ext/jetty-html-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/core/jetty6-html-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/core
    ln -sf jetty6-%{version}.jar jetty6.jar
    ln -sf jetty6-util-%{version}.jar jetty6-util.jar
    ln -sf jetty6-html-%{version}.jar jetty6-html.jar
popd
# ================= End of Jetty-Core subpackage install

# ================= Start of Jetty-Ext subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/ext
install -m 644 extras/ajp/target/jetty-ajp-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/ext/jetty6-ajp-%{version}.jar
install -m 644 lib/ext/jetty-client-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/ext/jetty6-client-%{version}.jar
install -m 644 lib/ext/jetty-java5-threadpool-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/ext/jetty6-java5-threadpool-%{version}.jar
install -m 644 lib/ext/jetty-servlet-tester-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/ext/jetty6-servlet-tester-%{version}.jar
install -m 644 lib/ext/jetty-sslengine-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/ext/jetty6-sslengine-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/ext
    ln -sf jetty6-ajp-%{version}.jar jetty6-ajp.jar
    ln -sf jetty6-client-%{version}.jar jetty6-client.jar
    ln -sf jetty6-java5-threadpool-%{version}.jar jetty6-java5-threadpool.jar
    ln -sf jetty6-servlet-tester-%{version}.jar jetty6-servlet-tester.jar
    ln -sf jetty6-sslengine-%{version}.jar jetty6-sslengine.jar
popd
# ================= End of Jetty-Ext subpackage install

# ================= Start of Jetty-Plus subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/plus
install -m 644 lib/plus/jetty-plus-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/plus/jetty6-plus-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/plus
    ln -sf jetty6-plus-%{version}.jar jetty6-plus.jar
popd
# ================= End of Jetty-Plus subpackage install

# ================= Start of Jetty-Annotations subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/annotations
install -m 644 lib/annotations/jetty-annotations-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/annotations/jetty6-annotations-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/annotations
    ln -sf jetty6-annotations-%{version}.jar jetty6-annotations.jar
    ln -sf $(build-classpath geronimo-annotation-1.0-api)
popd
# ================= End of Jetty-Annotations subpackage install

# ================= Start of Jetty-Management subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/management/mx4j
install -m 644 lib/management/jetty-management-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/management/jetty6-management-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/management
    ln -sf jetty6-management-%{version}.jar jetty6-management.jar
    pushd mx4j
        ln -sf $(build-classpath mx4j/mx4j)
        ln -sf $(build-classpath mx4j/mx4j-tools)
    popd
popd
# ================= End of Jetty-Management subpackage install

# ================= Start of Jetty-Naming subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/naming
install -m 644 lib/naming/jetty-naming-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/naming/jetty6-naming-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/naming
    ln -sf jetty6-naming-%{version}.jar jetty6-naming.jar
    ln -sf $(build-classpath jaf_1_1_api)
    ln -sf $(build-classpath javamail_1_4_api)
popd
# ================= End of Jetty-Naming subpackage install

# ================= Start of Jetty-XBean subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/xbean
install -m 644 lib/xbean/jetty-xbean-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/xbean/jetty6-xbean-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/xbean
    ln -sf jetty6-xbean-%{version}.jar jetty6-xbean.jar
popd
# ================= End of Jetty-XBean subpackage install


# ================= Start of Jetty-Spring subpackage install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6/spring
install -m 644 extras/spring/target/jetty-spring-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6/spring/jetty6-spring-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6/spring
    ln -sf jetty6-spring-%{version}.jar jetty6-spring.jar
popd
# ================= End of Jetty-Spring subpackage install


install -d -m 755 ${RPM_BUILD_ROOT}%{_datadir}/maven2/plugins
# ================= Start of Jetty Maven2-Plugins subpackages install
install -d -m 755 ${RPM_BUILD_ROOT}%{_javadir}/jetty6-maven2
install -m 644 modules/jspc-maven-plugin/target/maven-jetty-jspc-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6-maven2/jetty-jspc-maven-plugin-%{version}.jar
install -m 644 modules/maven-plugin/target/maven-jetty-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jetty6-maven2/jetty-maven-plugin-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_javadir}/jetty6-maven2
    ln -sf jetty-jspc-maven-plugin-%{version}.jar jetty-jspc-maven-plugin.jar
    ln -sf jetty-maven-plugin-%{version}.jar jetty-maven-plugin.jar
popd
pushd ${RPM_BUILD_ROOT}%{_datadir}/maven2/plugins
    ln -sf %{_javadir}/%{name}-maven2/jetty-jspc-maven-plugin-%{version}.jar jetty-jspc-maven-plugin.jar
    ln -sf %{_javadir}/%{name}-maven2/jetty-maven-plugin-%{version}.jar jetty-maven-plugin.jar
popd
# ================= End of Jetty Maven2-Plugin subpackages install

# build initial path structure
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{homedir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{appdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{ctxdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{confdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{logdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/etc/init.d



# install etc files <jetty-root>/etc
install -m 644 etc/start.config ${RPM_BUILD_ROOT}%{confdir}/start.config
install -m 644 etc/jetty.conf ${RPM_BUILD_ROOT}%{confdir}/jetty.conf
install -m 644 etc/jetty.xml ${RPM_BUILD_ROOT}%{confdir}/jetty.xml
install -m 644 etc/jetty-bio.xml ${RPM_BUILD_ROOT}%{confdir}/jetty-bio.xml
install -m 644 etc/jetty-jmx.xml ${RPM_BUILD_ROOT}%{confdir}/jetty-jmx.xml
install -m 644 etc/jetty-plus.xml ${RPM_BUILD_ROOT}%{confdir}/jetty-plus.xml
install -m 644 etc/jetty-ssl.xml ${RPM_BUILD_ROOT}%{confdir}/jetty-ssl.xml
install -m 644 etc/webdefault.xml ${RPM_BUILD_ROOT}%{confdir}/webdefault.xml
install -m 644 etc/realm.properties ${RPM_BUILD_ROOT}%{confdir}/realm.properties
install -m 644 etc/jdbcRealm.properties ${RPM_BUILD_ROOT}%{confdir}/jdbcRealm.properties
install -m 644 etc/keystore ${RPM_BUILD_ROOT}%{confdir}/keystore

# install bin files <jetty-root>/bin
install -m 644 bin/jetty.sh ${RPM_BUILD_ROOT}/etc/init.d/jetty6

# FHS Symlink for Jetty Home
pushd ${RPM_BUILD_ROOT}%{homedir}
    %{__ln_s} %{appdir} webapps
    %{__ln_s} %{ctxdir} contexts
    %{__ln_s} %{confdir} etc
    %{__ln_s} %{libdir} lib
    %{__ln_s} %{logdir} logs
popd

(cd $RPM_BUILD_ROOT%{_javadir}/jetty6 && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in jetty6*-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

echo maven depmap
%add_to_maven_depmap org.mortbay.jetty project %{version} JPP/jetty6 project
%add_to_maven_depmap org.mortbay.jetty jetty %{version} JPP/jetty6/core jetty6
%add_to_maven_depmap org.mortbay.jetty jetty-html %{version} JPP/jetty6/core jetty6-html
%add_to_maven_depmap org.mortbay.jetty jetty-util %{version} JPP/jetty6/core jetty6-util
%add_to_maven_depmap org.mortbay.jetty jetty-annotations %{version} JPP/jetty6/annotations jetty6-annotations
%add_to_maven_depmap org.mortbay.jetty jetty-naming %{version} JPP/jetty6/naming jetty6-naming
%add_to_maven_depmap org.mortbay.jetty jetty-management %{version} JPP/jetty6/management jetty6-management
%add_to_maven_depmap org.mortbay.jetty jetty-plus %{version} JPP/jetty6/plus jetty6-plus
%add_to_maven_depmap org.mortbay.jetty servlet-api-2.5 %{version} JPP jetty6-servlet-2.5-api
%add_to_maven_depmap org.mortbay.jetty jsp-api-2.1 %{version} JPP/jetty6/jsp-2.1 jsp-api-2.1
%add_to_maven_depmap org.mortbay.jetty jsp-2.1 %{version} JPP/jetty6/jsp-2.1 jsp-2.1
%add_to_maven_depmap org.mortbay.jetty jsp-api-2.0 %{version} JPP/jetty6/jsp-2.0 jsp-api-2.0
%add_to_maven_depmap org.mortbay.jetty jsp-2.0 %{version} JPP/jetty6/jsp-2.0 jsp-2.0
%add_to_maven_depmap org.mortbay.jetty jetty-ajp %{version} JPP/jetty6/ext jetty6-ajp
%add_to_maven_depmap org.mortbay.jetty jetty-client %{version} JPP/jetty6/ext jetty6-client
%add_to_maven_depmap org.mortbay.jetty jetty-java5-threadpool %{version} JPP/jetty6/ext jetty6-java5-threadpool
%add_to_maven_depmap org.mortbay.jetty jetty-servlet-tester %{version} JPP/jetty6/ext jetty6-servlet-tester
%add_to_maven_depmap org.mortbay.jetty jetty-sslengine %{version} JPP/jetty6/ext jetty6-sslengine
%add_to_maven_depmap org.mortbay.jetty jetty-spring %{version} JPP/jetty6/spring jetty6-spring
%add_to_maven_depmap org.mortbay.jetty jetty-xbean %{version} JPP/jetty6/xbean jetty6-xbean
%add_to_maven_depmap org.mortbay.jetty maven-jetty-jspc-plugin %{version} JPP/jetty6-maven2 jetty-jspc-maven-plugin
%add_to_maven_depmap org.mortbay.jetty maven-jetty-plugin %{version} JPP/jetty6-maven2 jetty-maven-plugin


echo poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-project.pom
install -m 644 modules/annotations/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-annotations.pom
install -m 644 modules/jetty/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6.pom
install -m 644 modules/html/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-html.pom
install -m 644 modules/util/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-util.pom
install -m 644 modules/naming/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-naming.pom
install -m 644 modules/management/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-management.pom
install -m 644 modules/plus/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-plus.pom
install -m 644 modules/servlet-api-2.5/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-servlet-2.5-api.pom
install -m 644 modules/jsp-api-2.1/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.1-api.pom
install -m 644 modules/jsp-2.1/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.1.pom
install -m 644 modules/jsp-api-2.0/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.0-api.pom
install -m 644 modules/jsp-2.0/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.0.pom
install -m 644 extras/ajp/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-ajp.pom
install -m 644 extras/client/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-client.pom
install -m 644 extras/servlet-tester/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-servlet-tester.pom
install -m 644 extras/spring/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-spring.pom
install -m 644 extras/sslengine/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-sslengine.pom
install -m 644 extras/xbean/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-xbean.pom
install -m 644 extras/threadpool/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-jetty6-java5-threadpool.pom
install -m 644 modules/jspc-maven-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-maven2-jetty-jspc-maven-plugin.pom
install -m 644 modules/maven-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jetty6-maven2-jetty-maven-plugin.pom

echo javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink



# ********************* CLEAN SECTION **************************
%clean
rm -rf $RPM_BUILD_ROOT



# ********************* POST-INSTALL AND POST-UNISTALL SECTION **************************


# ========= Start of Jetty package Post-Install and Post-Uninstall    
# Post-Install
%post
%update_maven_depmap

# Post-Uninstall
%postun
%update_maven_depmap

# ========= End of Jetty package Post-Install and Post-Uninstall    


# ========= Start of JAVADOC Subpackage Post-Install and Post-Uninstall    
# Post-Install
%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

# Post-Uninstall
%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi
# ========= End of JAVADOC Subpackage Post-Install and Post-Uninstall    



# ========= Start of Servlet 2.5 Subpackage Post-Install and Post-Uninstall    
# Post-Install
%post -n %{jettyname}6-servlet-%{servletspec}-api
update-alternatives --install %{_javadir}/servlet.jar servlet \
    %{_javadir}/%{jettyname}6-servlet-%{servletspec}-api.jar 20600

# Post-Uninstall    
%postun -n %{jettyname}6-servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    update-alternatives --remove servlet \
        %{_javadir}/%{jettyname}6-servlet-%{servletspec}-api.jar
fi
# ========= End of Servlet 2.5 Subpackage Post-Install and Post-Uninstall    


# ========= Start of JSP 2.1 Subpackage Post-Install and Post-Uninstall

# Post-Install
%post -n %{jettyname}6-jsp-%{jspspec}
update-alternatives --install %{_javadir}/jsp.jar jsp \
    %{_javadir}/jetty6-jsp-2.1-api/jsp-api-2.1.jar 20001

# Post-Uninstall
%postun -n %{jettyname}6-jsp-%{jspspec}
if [ "$1" = "0" ]; then
    update-alternatives --remove jsp \
        %{_javadir}/jetty6-jsp-2.1-api/jsp-api-2.1.jar
fi

# ========= End of JSP 2.1 Subpackage Post-Install and Post-Uninstall



# ========= Start of jetty core Subpackage Post-Install and Post-Uninstall

# Post-Install
%post -n %{jettyname}6-core

# Post-Uninstall
%postun -n %{jettyname}6-core

# ========= End of jetty core Subpackage Post-Install and Post-Uninstall



# ========= Start of jetty plus Subpackage Post-Install and Post-Uninstall

# Post-Install
%post -n %{jettyname}6-plus

# Post-Uninstall
%postun -n %{jettyname}6-plus

# ========= End of jetty plus Subpackage Post-Install and Post-Uninstall




# ********************* Files SECTION **************************



# ========= Start of Jetty package Files
%files
%defattr(-,root,root,-)
%{appdir}
%{ctxdir}
%dir %{_javadir}/jetty6
%{_javadir}/jetty6/*.jar
%attr(755,root,root) /etc/init.d/jetty6

%dir %{confdir}
%config(noreplace) %{confdir}/*.config
%config(noreplace) %{confdir}/*.conf
%config(noreplace) %{confdir}/*.xml
%config(noreplace) %{confdir}/*.properties
%config(noreplace) %{confdir}/keystore

%{homedir}
%{_mavendepmapfragdir}
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
%attr(0775,root,root) %dir %{logdir}

# ========= End of Jetty package Files

# ========= Start of Servlet Subpackage Files
%files -n %{jettyname}6-servlet-%{servletspec}-api
%defattr(-,root,root,-)
%{_javadir}/%{jettyname}6-servlet-%{servletspec}-api*.jar
%{_datadir}/maven2/poms/JPP.jetty6-servlet-2.5-api.pom
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Servlet Subpackage Files


# ========= Start of JSP 2.1 Subpackage Files
%files -n %{jettyname}6-jsp-%{jspspec}
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/jsp-2.1
%{_javadir}/jetty6/jsp-2.1/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.1-api.pom
%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.1.pom
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of JSP 2.1 Subpackage Files

# ========= Start of JSP 2.0 Subpackage Files
%files -n %{jettyname}6-jsp-2.0
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/jsp-2.0
%{_javadir}/jetty6/jsp-2.0/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.0-api.pom
%{_datadir}/maven2/poms/JPP.jetty6-jsp-2.0.pom
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of JSP 2.1 Subpackage Files

# ========= Start of Jetty core Subpackage Files
%files -n %{jettyname}6-core
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/core
%{_javadir}/jetty6/core/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-project.pom
%{_datadir}/maven2/poms/JPP.jetty6-jetty6.pom
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-util.pom
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-html.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty core  Subpackage Files

# ========= Start of Jetty ext Subpackage Files
%files -n %{jettyname}6-ext
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/ext
%{_javadir}/jetty6/ext/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-ajp.pom
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-client.pom
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-java5-threadpool.pom
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-servlet-tester.pom
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-sslengine.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty ext  Subpackage Files

# ========= Start of Jetty plus Subpackage Files
%files -n %{jettyname}6-plus
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/plus
%{_javadir}/jetty6/plus/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-plus.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty plus  Subpackage Files


# ========= Start of Jetty annotations Subpackage Files
%files -n %{jettyname}6-annotations
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/annotations
%{_javadir}/jetty6/annotations/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-annotations.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty annotations  Subpackage Files

# ========= Start of Jetty management Subpackage Files
%files -n %{jettyname}6-management
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/management
%{_javadir}/jetty6/management/*.jar
%{_javadir}/jetty6/management/mx4j
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-management.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty management  Subpackage Files

# ========= Start of Jetty naming Subpackage Files
%files -n %{jettyname}6-naming
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/naming
%{_javadir}/jetty6/naming/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-naming.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty naming  Subpackage Files

# ========= Start of Jetty spring Subpackage Files
%files -n %{jettyname}6-spring
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/spring
%{_javadir}/jetty6/spring/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-spring.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty spring  Subpackage Files

# ========= Start of Jetty xbean Subpackage Files
%files -n %{jettyname}6-xbean
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6/xbean
%{_javadir}/jetty6/xbean/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-jetty6-xbean.pom
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty xbean  Subpackage Files

# ========= Start of Jetty Maven Plugins Subpackage Files
%files -n %{jettyname}6-maven2-plugins
%defattr(-,root,root,-)
%dir %{_javadir}/jetty6-maven2
%{_javadir}/jetty6-maven2/*.jar
%{_datadir}/maven2/poms/JPP.jetty6-maven2-jetty-jspc-maven-plugin.pom
%{_datadir}/maven2/poms/JPP.jetty6-maven2-jetty-maven-plugin.pom
%{_datadir}/maven2/plugins/*
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty Maven Plugin Subpackage Files

# ========= Start of Jetty Javadoc Subpackage Files
%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}
%doc *.txt
%doc LICENSES/LICENSE.txt
%doc LICENSES/NOTICE.txt
# ========= End of Jetty Javadoc Subpackage Files

%changelog
* Thu Feb 14 2008 Ralph Apel <r.apel at r-apel.de> - 0:6.1.7-2jpp
- Add BRs based on mock verification build
- Have each subpackage require the main package to pull in 
  poms and depmap frags
- Let the main package Require -core
- TODO: some better solution 

* Wed Feb 06 2008 Ralph Apel <r.apel at r-apel.de> - 0:6.1.7-1jpp
- 6.1.7 final
- Split install from javadoc
- Add maven-plugin poms and depmap frags

* Mon Oct 29 2007 Ralph Apel <r.apel at r-apel.de> - 0:6.1.6-0.rc0.1jpp
- Upgrade from 6.1.5 to 6.1.6 :-)
- Activate more modules

* Wed Oct 01 2007 Greg Wilkins <Gregw at webtide.com> - 0:6.1.5-2jpp
- First server release to JPP-5.0

* Fri Jul 20 2007 Ralph Apel <r.apel at r-apel.de> - 0:6.1.5-1jpp
- First release

